#include <iostream>
#include <bits/stdc++.h>

using namespace std;
vector<vector<char> > arr;
vector<vector<int> > used;
vector<vector<int> > t;


int dfs(int x, int y, int c, int e)
{
    used[x][y] = c;
    t[x][y] = e;
    if (arr[x][y] == 'E')
    {
        if (used[x][y + 1] == 0)
        {
            return dfs(x, y + 1, c, e + 1);
        }
        else if (used[x][y + 1] == c)
        {
            return e - t[x][y + 1] + 1;
        }
        else
        {
            return 0;
        }
    }
    if (arr[x][y] == 'W')
    {
        if (used[x][y - 1] == 0)
        {
            return dfs(x, y - 1, c, e + 1);
        }
        else if (used[x][y - 1] == c)
        {
            return e - t[x][y - 1] + 1;
        }
        else
        {
            return 0;
        }
    }
    if (arr[x][y] == 'N')
    {
        if (used[x - 1][y] == 0)
        {
            return dfs(x - 1, y, c, e + 1);
        }
        else if (used[x - 1][y] == c)
        {
            return e - t[x - 1][y] + 1;
        }
        else
        {
            return 0;
        }
    }
    if (arr[x][y] == 'S')
    {
        if (used[x + 1][y] == 0)
        {
            return dfs(x + 1, y, c, e + 1);
        }
        else if (used[x + 1][y] == c)
        {
            return e - t[x + 1][y] + 1;
        }
        else
        {
            return 0;
        }
    }
}

int main()
{
    freopen("robots.in", "r", stdin);
    freopen("robots.out", "w", stdout);
    int n, m, g;
    cin >> n >> m >> g;
    arr.resize(n);
    for (int i = 0; i < n; i++)
        arr[i].resize(m);
    used.resize(n);
    for (int i = 0; i < n; i++)
        used[i].resize(m, 0);
    t.resize(n);
    for (int i = 0; i < n; i++)
        t[i].resize(m, 0);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
            cin >> arr[i][j];
    }
    int  k = 0;
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (used[i][j] == 0)
            {
                k++;
                ans += dfs(i, j, k, 0);
            }
        }
    }
    cout << ans << endl;
    return 0;
}
